package com.dxhy.core.controller;

import com.dxhy.auth.client.annotation.IgnoreClientToken;
import com.dxhy.common.utils.R;
import com.dxhy.core.entity.frJob.FrRequestDto;
import com.dxhy.core.service.frJob.RecordToQueryService;
import com.rabbitmq.client.Return;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

@Slf4j
@RestController
@RequestMapping("/frData")
public class FrDataProcessController {

    @Resource
    private RecordToQueryService recordToQueryService;

    @ResponseBody
    @IgnoreClientToken
    @PostMapping("/dataProcess")
    public R dataProcess(@RequestBody FrRequestDto requestParam) {

        if (requestParam == null || StringUtils.isBlank(requestParam.getProcessType())){
            return R.error("请求参数不能为空");
        }

        R r = R.ok();
        switch (requestParam.getProcessType()) {
            case "1":
                r = recordToQueryService.processJxDataByBzdh(requestParam);
                break;
            case "2":
                r = recordToQueryService.processJxDataByTime(requestParam);
                break;
            case "3":
                r = recordToQueryService.processXxDataByBzdh(requestParam);
                break;
            case "4":
                r = recordToQueryService.processXxDataByTime(requestParam);
                break;
            case "5":
                r = recordToQueryService.processZyDataByBzdh(requestParam);
                break;
            case "6":
                r = recordToQueryService.processZyDataByTime(requestParam);
                break;
            case "7":
                r = recordToQueryService.refreshAuthStatus(requestParam);
                break;
            default:
                r = R.error("请求参数错误");
                break;
        }

        return r;
    }

}
