package com.dxhy.core.service.frJob;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dxhy.core.dao.frTask.QueryDetailDataDao;
import com.dxhy.core.enmu.FplxEnmu;
import com.dxhy.core.entity.frJob.VoucherRecordQuery;
import com.dxhy.core.entity.frJob.VoucherRecordQueryDetail;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service("queryDetailDataService")
public class QueryDetailDataServiceImpl extends ServiceImpl<QueryDetailDataDao, VoucherRecordQueryDetail>
        implements QueryDetailDataService {

    @Autowired
    private QueryDetailDataDao queryDetailDataDao;

    private static final String JXZZS = "22210101";

    private static final String XXZZS = "22210102";

    private static final String ZYYWSR = "6001";


    @Override
    public void insertJxDataToQueryDetail(int pageSize){

        String[] time = getTime(JXZZS);

        //是否继续循环
        boolean hasNext = true;
        //页数
        int pageNum = 1;

        while (hasNext){
            PageHelper.startPage(pageNum,pageSize);
            //2.按照时间查询增量数据
            List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getDataFromRecord(time[0], time[1],JXZZS);
            //3.添加发票类型
            if (dataFromRecordItems != null && dataFromRecordItems.size() != 0){

                dataFromRecordItems.stream().forEach(e->e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
                //4.添加入库
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
                PageInfo<VoucherRecordQueryDetail> pageInfo = new PageInfo<>(dataFromRecordItems);
                hasNext = pageInfo.isHasNextPage();
                pageNum++;

            }else {
                hasNext = false;
            }
        }


    }

    @Override
    public void insertXxDataToQueryDetail(int pageSize){

        String[] time = getTime(XXZZS);

        //是否继续循环
        boolean hasNext = true;
        //页数
        int pageNum = 1;

        while (hasNext){
            PageHelper.startPage(pageNum,pageSize);
            //2.按照时间查询增量数据
            List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getDataFromRecordXx(time[0], time[1],XXZZS);
            //3.添加发票类型
            if (dataFromRecordItems != null && dataFromRecordItems.size() != 0){
                dataFromRecordItems.stream().forEach(e->e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
                //4.添加入库
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
                PageInfo<VoucherRecordQueryDetail> pageInfo = new PageInfo<>(dataFromRecordItems);
                hasNext = pageInfo.isHasNextPage();
                pageNum++;
            }else {
                hasNext = false;
            }
        }

    }

    @Override
    public void insertZyDataToQueryDetail(int pageSize){

        String[] time = getTime(ZYYWSR);

        //是否继续循环
        boolean hasNext = true;
        //页数
        int pageNum = 1;

        while (hasNext){
            PageHelper.startPage(pageNum,pageSize);
            //2.按照时间查询增量数据
            List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getDataFromRecordJe(time[0], time[1],ZYYWSR);
            //3添加发票类型
            if (dataFromRecordItems != null && dataFromRecordItems.size() != 0){
                dataFromRecordItems.stream().forEach(e->e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
                //4.添加入库
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);

                PageInfo<VoucherRecordQueryDetail> pageInfo = new PageInfo<>(dataFromRecordItems);
                hasNext = pageInfo.isHasNextPage();
                pageNum++;
            }else {
                hasNext = false;
            }
        }


    }

    @Override
    public String[] getTime(String km){
        //1.获取增量数据开始时间
        Date beginTime = queryDetailDataDao.getBeginTime(km);
        //2.第一次取原表时间
        if (beginTime == null){
            beginTime = queryDetailDataDao.getBeginTimefromRecord();
        }
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        //3.时间转换求结束日期
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(beginTime);
        calendar.add(Calendar.HOUR_OF_DAY,-1);
        //4.开始时间减一天
        String begin = format.format(calendar.getTime());
        //5.结束时间为现在加一天
        calendar.setTime(new Date());
        calendar.add(Calendar.DAY_OF_MONTH,1);
        String end = format.format(calendar.getTime());

        String[] time = {begin,end};
        return time;
    }

    @Override
    public List<String> getRzztDetail() {
        return queryDetailDataDao.getUuidByRzzt();
    }

    @Override
    public void updateRzzt(List<String> uuids) {
        if (uuids!= null && uuids.size() > 0){
            LambdaUpdateWrapper<VoucherRecordQueryDetail> updateWrap = new LambdaUpdateWrapper();
            updateWrap.in(VoucherRecordQueryDetail::getUuid,uuids);
            updateWrap.set(VoucherRecordQueryDetail::getRzzt,"1");
            this.update(updateWrap);
        }
    }

    @Override
    public void insertJxDataToQuery(Map<String, String> param) {

        //是否继续循环
        boolean hasNext = true;
        //页数
        int pageNum = 1;
        while (hasNext) {

            PageHelper.startPage(pageNum, 2000);
            List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getFrDataFromRecord(param);

            if (dataFromRecordItems != null && dataFromRecordItems.size() != 0) {

                dataFromRecordItems.stream().forEach(e -> e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
                //4.添加入库
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
                PageInfo<VoucherRecordQueryDetail> pageInfo = new PageInfo<>(dataFromRecordItems);
                hasNext = pageInfo.isHasNextPage();
                pageNum++;
            }else {
                hasNext = false;
            }
        }

    }

    @Override
    public void insertZyDataToQuery(Map<String, String> param) {

        //是否继续循环
        boolean hasNext = true;
        //页数
        int pageNum = 1;
        while (hasNext) {

            PageHelper.startPage(pageNum, 2000);
            List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getZyDataFromRecord(param);

            if (dataFromRecordItems != null && dataFromRecordItems.size() != 0) {

                dataFromRecordItems.stream().forEach(e -> e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
                //4.添加入库
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
                PageInfo<VoucherRecordQueryDetail> pageInfo = new PageInfo<>(dataFromRecordItems);
                hasNext = pageInfo.isHasNextPage();
                pageNum++;
            }else {
                hasNext = false;
            }
        }

    }


    @Override
    public void insertXxDataToQuery(Map<String, String> param) {

        //是否继续循环
        boolean hasNext = true;
        //页数
        int pageNum = 1;
        while (hasNext) {

            PageHelper.startPage(pageNum, 2000);
            List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getFrDataFromRecordXx(param);

            if (dataFromRecordItems != null && dataFromRecordItems.size() != 0) {

                dataFromRecordItems.stream().forEach(e -> e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
                //4.添加入库
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
                PageInfo<VoucherRecordQueryDetail> pageInfo = new PageInfo<>(dataFromRecordItems);
                hasNext = pageInfo.isHasNextPage();
                pageNum++;
            }else {
                hasNext = false;
            }
        }

    }

    @Override
    public void updateCxRzzt(List<String> cxRzzt) {
        if (cxRzzt!= null && cxRzzt.size() > 0){
            LambdaUpdateWrapper<VoucherRecordQueryDetail> updateWrap = new LambdaUpdateWrapper();
            updateWrap.in(VoucherRecordQueryDetail::getUuid,cxRzzt);
            updateWrap.set(VoucherRecordQueryDetail::getRzzt,"0");
            this.update(updateWrap);
        }
    }
}
